% Reorganized and revised figures for ACHA frame paper revision
% 10/04/08
% All figure numbers are based on the numbers in the revised document
% Eps files are created and put in the current directory
close all;
clear all;
clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Generating figures for Figure 1');

L=2.5; % limit of drawing box
a=sqrt(3);
UnbddFrameSetVert=[2 0; L (L-2)/a; L L; a*L-2 L; 1 a; 1 L; -1 L; -1 a; -(a*L-2) L; -L L; -L (L-2)/a; -2 0; -L -(L-2)/a; -L -L; -(a*L-2) -L; -1 -a; -1 -L; 1 -L; 1 -a; a*L-2 -L; L -L; L -(L-2)/a;];
OuterFrameSetVert=[2 0; 1 1/a; 1 a; 0 2/a; -1 a; -1 1/a; -2 0; -1 -1/a; -1 -a; 0 -2/a; 1 -a; 1 -1/a];
InnerFrameSetVert=[1 1/a; 0 2/a; -1 1/a; -1 -1/a; 0 -2/a; 1 -1/a];

% Fig 1a

figure(1);
clf;
hold on;
fill(UnbddFrameSetVert(:,1),UnbddFrameSetVert(:,2),2/3*[1 1 1],'EdgeColor','None')
fill(OuterFrameSetVert(:,1),OuterFrameSetVert(:,2),(1/3)*[1 1 1],'EdgeColor','None')
fill(InnerFrameSetVert(:,1),InnerFrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
exportfig(1,'Fig1aNoPSFrag.eps')
hold off;
close(1)

% Fig 1b

figure(1);
clf;
hold on;
fill(InnerFrameSetVert(:,1),InnerFrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
exportfig(1,'Fig1bNoPSFrag.eps')
hold off;
close(1)

% Fig 1c

figure(1);
clf;
hold on;
fill(OuterFrameSetVert(:,1),OuterFrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
exportfig(1,'Fig1cNoPSFrag.eps')
hold off;
close(1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Generating figures for Figure 2');

L=1.375;
theta=2*pi*(0:2^(-10):1);

% Fig 2a

M=2;
FrameSetVert=(2*sin(pi/(2*M))/sin(pi/M)*[cos(pi/(2*M)) -sin(pi/(2*M)); sin(pi/(2*M)) cos(pi/(2*M))]*[cos(2*pi*(0:2*M-1)/(2*M)); sin(2*pi*(0:2*M-1)/(2*M))])';
figure(1);
clf;
hold on;
fill(FrameSetVert(:,1),FrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
exportfig(1,'Fig2aNoPSFrag.eps')
hold off;
close(1)

% Fig 2b

M=4;
FrameSetVert=(2*sin(pi/(2*M))/sin(pi/M)*[cos(pi/(2*M)) -sin(pi/(2*M)); sin(pi/(2*M)) cos(pi/(2*M))]*[cos(2*pi*(0:2*M-1)/(2*M)); sin(2*pi*(0:2*M-1)/(2*M))])';
figure(1);
clf;
hold on;
fill(FrameSetVert(:,1),FrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
exportfig(1,'Fig2bNoPSFrag.eps')
hold off;
close(1)

% Fig 2c

M=6;
FrameSetVert=(2*sin(pi/(2*M))/sin(pi/M)*[cos(pi/(2*M)) -sin(pi/(2*M)); sin(pi/(2*M)) cos(pi/(2*M))]*[cos(2*pi*(0:2*M-1)/(2*M)); sin(2*pi*(0:2*M-1)/(2*M))])';
figure(1);
clf;
hold on;
fill(FrameSetVert(:,1),FrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
exportfig(1,'Fig2cNoPSFrag.eps')
hold off;
close(1)

% Fig 2d

M=2;
FrameSetVert=(2*sin(pi/(2*M))/sin(pi/M)*[cos(pi/(2*M)) -sin(pi/(2*M)); sin(pi/(2*M)) cos(pi/(2*M))]*[cos(2*pi*(0:2*M-1)/(2*M)); sin(2*pi*(0:2*M-1)/(2*M))])';
figure(1);
clf;
hold on;
fill(FrameSetVert(:,1),FrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
fill(cos(theta),sin(theta),.5*[1 1 1],'EdgeColor','None');
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
text(0,0,'C');
text(-.69,1.25,'E');
annotation('textarrow',[0.37,0.37],[0.87,0.82]);
exportfig(1,'Fig2dNoPSFrag.eps')
hold off;
close(1)

% Fig 2e

M=4;
FrameSetVert=(2*sin(pi/(2*M))/sin(pi/M)*[cos(pi/(2*M)) -sin(pi/(2*M)); sin(pi/(2*M)) cos(pi/(2*M))]*[cos(2*pi*(0:2*M-1)/(2*M)); sin(2*pi*(0:2*M-1)/(2*M))])';
figure(1);
clf;
hold on;
fill(FrameSetVert(:,1),FrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
fill(cos(theta),sin(theta),.5*[1 1 1],'EdgeColor','None');
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
text(0,0,'C');
text(-.42,1.25,'E');
annotation('textarrow',[0.43,0.43],[0.87,0.82]);
exportfig(1,'Fig2eNoPSFrag.eps')
hold off;
close(1)

% Fig 2f

M=6;
FrameSetVert=(2*sin(pi/(2*M))/sin(pi/M)*[cos(pi/(2*M)) -sin(pi/(2*M)); sin(pi/(2*M)) cos(pi/(2*M))]*[cos(2*pi*(0:2*M-1)/(2*M)); sin(2*pi*(0:2*M-1)/(2*M))])';
figure(1);
clf;
hold on;
fill(FrameSetVert(:,1),FrameSetVert(:,2),0*[1 1 1],'EdgeColor','None')
fill(cos(theta),sin(theta),.5*[1 1 1],'EdgeColor','None');
axis equal
axis(L*[-1 1 -1 1])
set(gca,'XTick',-1:1)
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',-1:1);
set(gca,'YTickLabel',{'bca','cab','cba'});
text(0,0,'C');
text(-.73,1.19,'E');
annotation('textarrow',[0.36,0.36],[0.85,0.75]);
exportfig(1,'Fig2fNoPSFrag.eps')
hold off;
close(1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Generating figures for Figure 3');

% default values
sigma=0.35;
r = 1;
L = 1.375;
MinX=-2;
MaxX=2;
epsilon=2^(-8);
PixLocOfMinusOneZeroOne=((MaxX-MinX)/2+[-1, 0 ,1])/epsilon;
PixLocOfMinusLLMinusLL=((MaxX-MinX)/2+[-L L -L L])/epsilon;
x=MinX:epsilon:MaxX;
y=x;
[X Y] = ndgrid(x,y);
[k l] = size(X);
Noise=exp((-1/(2*sigma^2)).*(X.^2+Y.^2));
Noise=circshift(Noise,[(k+1)/2 (k+1)/2]);
Noise=Noise./sum(sum(Noise));
a=-1;
b=1;

% Fig 3a

M=2;
Frame=[cos(pi*(0:M-1)/M); sin(pi*(0:M-1)/M)];
D=zeros(size(X));
for m=1:M
   Ip=Frame(1, m)*X+Frame(2,m)*Y;
   D=D+(Ip>a).*(Ip<b);
end
FrameSet=(D==M);
ErrorOfFrameSet=FrameSet&(ifft2(fft2(double(FrameSet)).*fft2(Noise))<=0.5);

figure(1);
clf;
image(255*(1-double(ErrorOfFrameSet)));
shading flat;
colormap gray;
axis equal
axis(PixLocOfMinusLLMinusLL);
set(gca,'XTick',PixLocOfMinusOneZeroOne);
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',PixLocOfMinusOneZeroOne);
set(gca,'YTickLabel',{'bca','cab','cba'});
box off
exportfig(1,'Fig3aNoPSFrag.eps')
close(1)

% Fig 3b

M=4;
Frame=[cos(pi*(0:M-1)/M); sin(pi*(0:M-1)/M)];
D=zeros(size(X));
for m=1:M
   Ip=Frame(1, m)*X+Frame(2,m)*Y;
   D=D+(Ip>a).*(Ip<b);
end
FrameSet=(D==M);
ErrorOfFrameSet=FrameSet&(ifft2(fft2(double(FrameSet)).*fft2(Noise))<=0.5);

figure(1);
clf;
image(255*(1-double(ErrorOfFrameSet)));
shading flat;
colormap gray;
axis equal
axis(PixLocOfMinusLLMinusLL);
set(gca,'XTick',PixLocOfMinusOneZeroOne);
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',PixLocOfMinusOneZeroOne);
set(gca,'YTickLabel',{'bca','cab','cba'});
box off
exportfig(1,'Fig3bNoPSFrag.eps')
close(1)

% Fig 3c

M=6;
Frame=[cos(pi*(0:M-1)/M); sin(pi*(0:M-1)/M)];
D=zeros(size(X));
for m=1:M
   Ip=Frame(1, m)*X+Frame(2,m)*Y;
   D=D+(Ip>a).*(Ip<b);
end
FrameSet=(D==M);
ErrorOfFrameSet=FrameSet&(ifft2(fft2(double(FrameSet)).*fft2(Noise))<=0.5);

figure(1);
clf;
image(255*(1-double(ErrorOfFrameSet)));
shading flat;
colormap gray;
axis equal
axis(PixLocOfMinusLLMinusLL);
set(gca,'XTick',PixLocOfMinusOneZeroOne);
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',PixLocOfMinusOneZeroOne);
set(gca,'YTickLabel',{'bca','cab','cba'});
box off
exportfig(1,'Fig3cNoPSFrag.eps')
close(1)

% Fig 3d

Class=(X.^2+Y.^2<=1);
ErrorOfClass=Class&(ifft2(fft2(double(Class)).*fft2(Noise))<=0.5);

figure(1);
clf;
image(255*(1-double(ErrorOfClass)));
shading flat;
colormap gray;
axis equal
axis(PixLocOfMinusLLMinusLL);
set(gca,'XTick',PixLocOfMinusOneZeroOne);
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',PixLocOfMinusOneZeroOne);
set(gca,'YTickLabel',{'bca','cab','cba'});
box off
exportfig(1,'Fig3dNoPSFrag.eps')
close(1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Generating figures for Figure 4');

M=3;
Frame=[cos(pi*(0:M-1)/M); sin(pi*(0:M-1)/M)];
D=zeros(size(X));
E=zeros(size(X));
for m=1:M
   Ip=Frame(1, m)*X+Frame(2,m)*Y;
   D=D+(Ip>a).*(Ip<b);
   E=E+erf((b-Ip)/(sqrt(2)*sigma))-erf((a-Ip)/(sqrt(2)*sigma));
end
FrameSet=(D==M);
ErrorOfFrameSet=FrameSet&(ifft2(fft2(double(FrameSet)).*fft2(Noise))<=0.5);
ErrorUpperBound=FrameSet&(E<2*M-1);

% Fig 4a

figure(1);
clf;
image(255*(1-double(transpose(ErrorOfFrameSet))));
shading flat;
colormap gray;
axis equal
axis(PixLocOfMinusLLMinusLL);
set(gca,'XTick',PixLocOfMinusOneZeroOne);
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',PixLocOfMinusOneZeroOne);
set(gca,'YTickLabel',{'bca','cab','cba'});
box off
exportfig(1,'Fig4aNoPSFrag.eps')
close(1)

% Fig 4b

figure(1);
clf;
image(255*(1-double(transpose(ErrorUpperBound))));
shading flat;
colormap gray;
axis equal
axis(PixLocOfMinusLLMinusLL);
set(gca,'XTick',PixLocOfMinusOneZeroOne);
set(gca,'XTickLabel',{'abc','acb','bac'});
set(gca,'YTick',PixLocOfMinusOneZeroOne);
set(gca,'YTickLabel',{'bca','cab','cba'});
box off
exportfig(1,'Fig4bNoPSFrag.eps')
close(1)
